#include <S:\Engine\Graphics\UI.h>

#include <S:\Engine\Log\Logger.h>

#include <vector>

Microsoft::WRL::ComPtr<ID2D1DeviceContext2> pD2DDeviceCont{ nullptr };
Microsoft::WRL::ComPtr<IDWriteFactory> pDWriteFactor{nullptr};

void SetGUIContext(Microsoft::WRL::ComPtr<ID2D1DeviceContext2> pD2DCont, Microsoft::WRL::ComPtr<IDWriteFactory> pDWFactory) {
	pD2DDeviceCont = pD2DCont;
	pDWriteFactor = pDWFactory;
}

void DeleteGUIContext() {
	Log_Write("** Releasing of GUI **");
	pD2DDeviceCont.Reset();
	Log_Write("\tDevice Context Released");
	pDWriteFactor.Reset();
	Log_Write("\tWrite Factor Released");

	Log_Write("** GUI Released **");
}

std::vector<Control> ctrl{};

bool CreateUXWindow(unsigned short type, std::wstring name, DWORD style, int X, int Y, int W, int H, UINT32 f_id, Window parent) {
	Control wnd{};

	ErrorHR(pD2DDeviceCont->CreateSolidColorBrush(D2D1::ColorF(D2D1::ColorF::WhiteSmoke), &wnd.pTextBrush));

	ErrorHR(pD2DDeviceCont->CreateSolidColorBrush(D2D1::ColorF(D2D1::ColorF::White), &wnd.BorderBrush));

	ErrorHR(pDWriteFactor->CreateTextFormat(L"Verdana", NULL, DWRITE_FONT_WEIGHT_NORMAL, DWRITE_FONT_STYLE_NORMAL, DWRITE_FONT_STRETCH_NORMAL, 24, L"pl-PL", &wnd.pTextFormat));

	ErrorHR(wnd.pTextFormat->SetTextAlignment(DWRITE_TEXT_ALIGNMENT_CENTER));

	ErrorHR(wnd.pTextFormat->SetParagraphAlignment(DWRITE_PARAGRAPH_ALIGNMENT_CENTER));

	wnd.SetName(name);
	wnd.SetBorder(true);
	wnd.SetType(type);
	wnd.SetWindowRect(X, Y, W, H);

	ctrl.push_back(wnd);

	return true;
}

bool CreateUXWindow(std::wstring cname, std::wstring name, DWORD style, int X, int Y, int W, int H, UINT32 f_id) {

	return true;
}

void DestroyAllWindows() {
	ctrl.clear();
	Log_Write("** All Controls are Released **");
}

void RenderStatic(Control &current, Window Parent) {
	D2D1_RECT_F Wnd{};

	MyRect rc{};
	rc = current.GetWindowRect();

	Wnd = D2D1::RectF(static_cast<FLOAT>(rc.x), static_cast<FLOAT>(rc.y), static_cast<FLOAT>(rc.x + rc.w), static_cast<FLOAT>(rc.y + rc.h));
	if (current.HasBorder()) {
		pD2DDeviceCont->DrawRectangle(&Wnd, current.BorderBrush.Get(), 2, NULL);
	}

	pD2DDeviceCont->DrawTextW(current.GetName().c_str(), static_cast<UINT32>(wcslen(current.GetName().c_str())), current.pTextFormat.Get(), &Wnd, current.pTextBrush.Get());
}

void RenderUI() {
	for (auto &e : ctrl) {
		if (e.GetType() == STATIC) {
			RenderStatic(e, 0);
		}
	}
}