#include <S:\Engine\Graphics\Graphics3D.h>

#include <S:\Engine\WinMain.h>

#include <S:\Engine\Log\Logger.h>
#include <S:\Engine\Config.h>

#include <Windows.h>

#include <memory>

const short St1{ 100 };
const short St2{ 101 };
const short St3{ 102 };

class Entry : public WMainProg {
public:
	std::unique_ptr<D12Graphics> Gfx;
public:
	Entry() { Log_Open("Logger.txt"); Log_Write("** Program Start **"); };
	~Entry() {}

	void wndproc(MSG uMsg) { }

	void Loop();
	void Start();
};

void Entry::Start() {
	SetWindowName(L"DirectX12 - User Interface");
	Gfx->InitGraphics(MainWnd);
	Gfx->SetBgkColor(0.1f, 0.1f, 0.1f, 1.0f);

	CreateUXWindow(STATIC, L"HelloWorld", 0, 10, 10, 250, 50, St1, 0);
	CreateUXWindow(STATIC, L"miss you much", 0, 270, 80, 250, 50, St2, 0);
	CreateUXWindow(STATIC, L"Bye Bye for now", 0, 530, 150, 250, 50, St3, 0);
}

void Entry::Loop() {
	Gfx->Render();
}

int WINAPI wWinMain(HINSTANCE hInst, HINSTANCE hPrevInst, LPWSTR, int) {
	auto main = std::make_unique <Entry>();

	main->Gfx = std::make_unique<D12Graphics>();

	if (!main->Gfx->CheckSupport()) {
		std::cout << "No Support for DirectX12\n";
		Log_Write("\tNo Support for DirectX12\n");

		return 1;
	}
	
	main->Gfx->CheckVersionSupport();

	Config cfg{};

	LoadConfig(cfg, L"Config.cfg");
	if (!main->Gfx->GetResolutions(cfg)) {
		Log_Write("\tScreen Res failed\n");

		return 1;
	}

	SaveConfig(cfg, L"Config.cfg");

	WMainClass wmc{};

	wmc.Width = cfg.Width;
	wmc.Height = cfg.Height;

	main->Create(wmc);

	return 0;
}